<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 1</H1>

<P>
Modules, Objets et Calcul Formel<BR>
 Sylvain Boulmé, Thérèse Hardin & Renaud Rioboo<BR>

<H2>1</H2>

<P>
Nom du rapporteur: Damien Doligez

<P>Confiance en la note: 3

<P>Notation du papier: 5


<P>Commentaires aux auteurs:

<P>Excellent papier.

<P>Avez-vous envisage une approche consistant a definir un langage adapte
a vos buts, ou meme une extension de Ocaml pour ajouter des traits
permettant d'exprimer exactement l'architecture de votre librairie ?
Est-ce une solution viable ?  Pourquoi ?

<P>A la fin du paragraphe 3.2.1, vous dites "cette solution n'est pas
viable".  Quels sont les problemes ? (trop de duplication de code ?
code illisible ? maintenance impossible ? autre chose ?)  Faites-nous
profiter de votre experience.


<P>Commentaires réservés au comité de programme:

<P>Un exemple d'utilisation en vraie grandeur des systemes de modules et
d'objets, avec les problemes que ca pose dans la realite (par
opposition aux exemples "jouets" qu'on trouve dans les papiers
decrivant les systemes de modules).

<P>Ce papier est bien ecrit, clair, facile a comprendre, et apporte des
informations importantes.



<H2>2</H2>

<P>Nom du rapporteur: Pierre Weis

<P>Confiance en la note: 3
<P>  1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.

<P>Notation du papier: 4
<P>  1: a rejeter; 2: ininteressant; 3: acceptable;
<P>  4: bon papier; 5: tres bon papier

<P>Commentaires aux auteurs:

<P>Un bon papier qui explique correctement les alternatives qui s'offrent
à qui veut modéliser la hiérarchie des structures mathématiques
utilisées dans un système de calcul formel. La solution retenue à base
de modules et d'objets polymorphes est originale et intéressante. Elle
fait irrésistiblement penser aux traits du langage Alcool, puisque les
objets ne sont là que pour apporter la surcharge et la spécification
des structures mathématiques modélisées. Pourriez-vous aborder en
quelques mots une comparaison de votre approche avec Alcool ?

<P>Je n'ai pas compris pourquoi la solution uniquement à base de
modules «n'est pas viable».

<P>Vous n'avez pas non plus envisagé dans l'article le codage de ces
structures dans les types de base du langage (type 'a anneau = {
support : 'a; ....}). Avez-vous examiné et conclut à l'impossibilité
de ce codage ?

<P>D'autre part vous ne soulevez pas non plus l'alternative d'utiliser
des conversions explicites de structures (ring_of_field,
additive_group_of_ring, ...). Cette approche n'est-elle pas viable ?
Pourquoi ? Comment faites-vous pour obtenir un monoide à partir d'un
anneau ou encore obtenir un groupe à partir d'un corps sans préciser
explicitement de quelle sous-structure vous parlez ? 

<P>Enfin je n'ai pas parfaitement compris en quoi votre solution M5 résout tous
les problèmes posés, en particulier ceux liés à l'inclusion de
structures: pouvez-vous facilement considérer un corps comme un
monoïde ?

<P>Commentaires reserves au comite de programme:


</BODY>
</HTML>
